﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Threading;
using WSCF.Test.IService;

namespace WSCF.Test.Server
{
    public class Foo : IFooService
    {
        public int Number { get; protected set; }
        public DateTime AddFuncTime { get; protected set; }

        public event PropertyChangedEventHandler PropertyChanged;

        public DispatcherTimer timer = new DispatcherTimer();
        public Foo() 
        {
            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromSeconds(1);
            timer.Tick += Timer_Tick;
            timer.Start();
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            Number++;
        }

        public void Add(int a, int b, AsyncCBHandler asyncDelegate, object asyncContext)
        {
            Number = a + b;
            AddFuncTime = DateTime.Now;
            asyncDelegate?.Invoke(asyncContext, new FooServiceAddReponse() { result = Number });
        }
    }
}
